package kcode.statexmi2java.codegenerator;

import java.io.File;
import java.io.IOException;

import kcode.statexmi2java.smrepresentation.StateMachine;

/**
 * Allows for generation of sourcecode in a target folder from a statemachine
 */
public interface CodeGenerator {

  /**
   * generates sourcecode in target folder from a statemachine
   * 
   * @param stateMachine statemachine representation
   * @param toFolder target folder to generate code in
   * @throws IOException thrown when problems with target folder or files occur
   */
  public void generateCodeFor(StateMachine stateMachine, File toFolder) throws IOException;
}
