package kcode.statexmi2java.gui;

import java.awt.Desktop;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.IOException;
import java.util.List;

import javax.swing.JButton;
import javax.swing.JLabel;

import org.ciscavate.cjwizard.WizardPage;
import org.ciscavate.cjwizard.WizardSettings;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * CJWizard wizard page as last page
 */
public class WizardPageFinish extends WizardPage {
  // page constants
  public static final String WIZARDPAGE_TITLE = "Finish";
  public static final String WIZARDPAGE_DESC  = "Finish Page";
  private static final String TEXT_LABEL_FINISH = "Der Quellcode wurde generiert.";

  private static final long  serialVersionUID = 1;

  protected final Logger     logger           = LoggerFactory.getLogger(WizardPageFactory.class);

  protected final JButton    bOpenFolder      = new JButton("Quellcode-Verzeichnis öffnen");

  public WizardPageFinish(String targetFolderPath) {
    super(WIZARDPAGE_TITLE, WIZARDPAGE_DESC);

    initComponents(targetFolderPath);
  }

  @Override
  public void rendering(List<WizardPage> path, final WizardSettings settings) {
    super.rendering(path, settings);
    setNextEnabled(false);
    setFinishEnabled(true);
  }

  protected void initComponents(final String targetFolderPath) {
    add(new JLabel(TEXT_LABEL_FINISH));
    bOpenFolder.addActionListener(new ActionListener() {
      @Override
      public void actionPerformed(ActionEvent e) {
        try {
          Desktop.getDesktop().open(new File(targetFolderPath));
        } catch (IOException exc) {
        }
      }
    });
    add(bOpenFolder);
  }
}
