package kcode.statexmi2java.smrepresentation;

/**
 * behavior representation
 * UML Behavior: state activities, transition effects
 */
public class Behavior {
	public String name;
	public String body;
	
	@Override
	public String toString() {
	  StringBuilder sB = new StringBuilder();
	  return sB.append(name).append(" {").append(body).append("}").toString();
	}
	
	@Override
	public boolean equals(Object obj) {
	  boolean equals;
    if (obj instanceof Behavior) {
	    equals = name.equals(((Behavior) obj).name) && body.equals(((Behavior) obj).body);
	  } else {
	    equals = super.equals(obj);
	  }
	  return equals;
	}

  @Override
  public int hashCode() {
    final int prime = 31;
    int result = 1;
    result = prime * result + ((body == null) ? 0 : body.hashCode());
    result = prime * result + ((name == null) ? 0 : name.hashCode());
    return result;
  }
}