package kcode.statexmi2java.smrepresentation;

import kcode.statexmi2java.smrepresentation.Behavior;

/**
 * state representation
 */
public class State {
  public String   name       = null;
  public boolean  isInitial  = false;
  public boolean  isFinal    = false;
  public Behavior entry      = null;
  public Behavior doActivity = null;
  public Behavior exit       = null;

  public String toString() {
    StringBuilder sB = new StringBuilder();
    sB.append(name).append(" (Behaviors: ").append(entry).append(", ").append(doActivity).append(", ").append(exit)
        .append(")");
    return sB.toString();
  }

  @Override
  public boolean equals(Object obj) {
    boolean equals = false;
    if (obj instanceof State) {
      equals = name.equals(((State) obj).name)
          && (entry == null ? entry == ((State) obj).entry : entry.equals(((State) obj).entry))
          && (doActivity == null ? doActivity == ((State) obj).doActivity : doActivity.equals(((State) obj).doActivity))
          && (exit == null ? exit == ((State) obj).exit : exit.equals(((State) obj).exit))
          && isInitial == ((State) obj).isInitial && isFinal == ((State) obj).isFinal;
    } else {
      equals = super.equals(obj);
    }
    return equals;
  }

  @Override
  public int hashCode() {
    final int prime = 31;
    int result = 1;
    result = prime * result + ((name == null) ? 0 : name.hashCode());
    result = prime * result + ((entry == null) ? 0 : entry.hashCode());
    result = prime * result + ((doActivity == null) ? 0 : doActivity.hashCode());
    result = prime * result + ((exit == null) ? 0 : exit.hashCode());
    result = prime * result + (isInitial ? 3 : 0);
    result = prime * result + (isFinal ? 4 : 0);
    return result;
  }
}
