package kcode.statexmi2java.smrepresentation;

import java.util.ArrayList;
import kcode.statexmi2java.smrepresentation.Transition;
import kcode.statexmi2java.smrepresentation.State;

/**
 * state machine representation
 */
public class StateMachine {
  public ArrayList<State>      states      = new ArrayList<State>();
  public ArrayList<Transition> transitions = new ArrayList<Transition>();

  public String toString() {
    StringBuilder sB = new StringBuilder();
    sB.append("\nSM (S").append(states.size()).append("; T").append(transitions.size()).append(")");
    for (State s : states) {
      sB.append("\n  S: ").append(s.toString());
    }
    for (Transition t : transitions) {
      sB.append("\n  T: ").append(t.toString());
    }
    return sB.toString();
  }

  @Override
  public boolean equals(Object obj) {
    boolean isEquals = false;
    if (obj instanceof StateMachine) {
      isEquals = states.containsAll(((StateMachine) obj).states) && transitions.containsAll(((StateMachine) obj).transitions);
    } else {
      isEquals = super.equals(obj);
    }
    return isEquals;
  }

  @Override
  public int hashCode() {
    final int prime = 31;
    int result = 1;
    result = prime * result + ((states == null) ? 0 : states.hashCode());
    result = prime * result + ((transitions == null) ? 0 : transitions.hashCode());
    return result;
  }
}
