package kcode.statexmi2java.smrepresentation;

import java.util.ArrayList;
import java.util.List;

/**
 * transition representation
 */
public class Transition {
  public String       name     = null;
  public List<String> triggers = new ArrayList<String>();
  public String       guard    = null;
  public State        from;
  public State        to;
  public Behavior     effect;

  public String toString() {
    StringBuilder sB = new StringBuilder();
    sB.append(name).append(": ").append(((from != null) ? from.name : "")).append(" --> ")
        .append((to != null) ? to.name : "").append(" (G: ").append(guard).append(", T: ").append(triggers.toString())
        .append(", E: ").append(effect).append(")");
    return sB.toString();
  }

  @Override
  public boolean equals(Object obj) {
    boolean eq;
    if (obj instanceof Transition) {

      eq = (name == null ? name == ((Transition) obj).name : name.equals(((Transition) obj).name))
          && triggers.equals(((Transition) obj).triggers)
          && (guard == null ? guard == ((Transition) obj).guard : guard.equals(((Transition) obj).guard))
          && from.equals(((Transition) obj).from) && to.equals(((Transition) obj).to)
          && (effect == null ? effect == ((Transition) obj).effect : effect.equals(((Transition) obj).effect));
    } else {
      eq = super.equals(obj);
    }
    return eq;
  }

  @Override
  public int hashCode() {
    final int prime = 31;
    int result = 1;
    result = prime * result + ((effect == null) ? 0 : effect.hashCode());
    result = prime * result + ((from == null) ? 0 : from.hashCode());
    result = prime * result + ((guard == null) ? 0 : guard.hashCode());
    result = prime * result + ((name == null) ? 0 : name.hashCode());
    result = prime * result + ((to == null) ? 0 : to.hashCode());
    result = prime * result + ((triggers == null) ? 0 : triggers.hashCode());
    return result;
  }
}
