package kcode.statexmi2java.xmireader;

import java.util.List;

import kcode.statexmi2java.smrepresentation.StateMachine;

/**
 * An XMI file reader
 * parses XMI files for state machines
 */
public interface IXMIReader {

  /**
   * initialize reader with the path to the XMI file which is to be read
   * @param xmiFilePath path to XMI file
   */
	public void initialize(String xmiFilePath);

	/**
	 * get the XMI version specified inside the XMI file
	 * @return XMI version
	 */
	public String getXMIVersion();

	/**
	 * get number of state machines
	 * @return number of state machines
	 */
	public int getNumberOfStateDiagrams();

	/**
	 * get state machine representations as list
	 * @return list of state machine representations
	 */
	public List<StateMachine> getStateMachines();
}