package codetemplates;

import java.util.Map;
import java.util.HashMap;

/**
 * abstract state factory
 * @param <S> StateIDs enum, identifying states
 * @param <T> Triggers enum, representing triggers
 */
public abstract class StateFactory<S extends Enum<S>, T extends Enum<T>> implements IStateFactory<S, T> {
  protected Map<S, ObjectState<S, T>> states = new HashMap<S, ObjectState<S, T>>();

  public StateFactory() {
    super();
    createStatesAndTransitions();
  }

  protected abstract void createStatesAndTransitions();

  public ObjectState<S, T> getState(S id) {
    return states.get(id);
  }
}
